Index: proj/libs/classes/include/classes.h
===================================================================
--- proj/libs/classes/include/classes.h	(nonexistent)
+++ proj/libs/classes/include/classes.h	(revision 331)
@@ -0,0 +1,14 @@
+#ifndef CLASSES_H_INCLUDED
+#define CLASSES_H_INCLUDED
+
+/**
+ * @defgroup    classes classes
+ * @brief Classes module
+ *
+ * Provides useful and general classes.
+ */
+
+#include "list.h"
+#include "queue.h"
+
+#endif //CLASSES_H_INCLUDED

Property changes on: proj/libs/classes/include/classes.h
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/libs/classes/include/list.h
===================================================================
--- proj/libs/classes/include/list.h	(revision 330)
+++ proj/libs/classes/include/list.h	(revision 331)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup    list_t    list_t
+ * @ingroup classes
  * @brief List module
  *
  * Can be used like a C++ std::list.
Index: proj/libs/classes/include/queue.h
===================================================================
--- proj/libs/classes/include/queue.h	(revision 330)
+++ proj/libs/classes/include/queue.h	(revision 331)
@@ -3,6 +3,7 @@
 
 /**
  * @defgroup    queue_t queue_t
+ * @ingroup classes
  * @brief Queue module
  *
  * Can be used like a C++ std::queue.
@@ -11,7 +12,6 @@
  * @{
  */
 
-
 struct queue;
 typedef struct queue queue_t;
 
Index: proj/libs/graph/include/basic_sprite.h
===================================================================
--- proj/libs/graph/include/basic_sprite.h	(nonexistent)
+++ proj/libs/graph/include/basic_sprite.h	(revision 331)
@@ -0,0 +1,28 @@
+#ifndef BASIC_SPRITE_H_INCLUDED
+#define BASIC_SPRITE_H_INCLUDED
+
+/**
+ * @defgroup basic_sprite_t basic_sprite_t
+ * @ingroup graph
+ * @brief Basic sprite module.
+ *
+ * A basic sprite allows to represent an image file.
+ *
+ * @{
+ */
+struct basic_sprite;
+typedef struct basic_sprite basic_sprite_t;
+
+basic_sprite_t* (basic_sprite_ctor)(const char *const *xpm, int16_t u0, int16_t v0);
+void            (basic_sprite_dtor)(basic_sprite_t *p);
+const uint8_t* (basic_sprite_get_map)(const basic_sprite_t *p);
+uint16_t       (basic_sprite_get_w)  (const basic_sprite_t *p);
+uint16_t       (basic_sprite_get_h)  (const basic_sprite_t *p);
+int16_t        (basic_sprite_get_u0) (const basic_sprite_t *p);
+int16_t        (basic_sprite_get_v0) (const basic_sprite_t *p);
+
+/**
+ * @}
+ */
+
+#endif //BASIC_SPRITE_H_INCLUDED

Property changes on: proj/libs/graph/include/basic_sprite.h
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/libs/graph/include/graph.h
===================================================================
--- proj/libs/graph/include/graph.h	(revision 330)
+++ proj/libs/graph/include/graph.h	(revision 331)
@@ -1,6 +1,15 @@
 #ifndef GRAPH_H_INCLUDED
 #define GRAPH_H_INCLUDED
 
+/**
+ * @defgroup    graph   graph
+ * @brief Graph module.
+ *
+ * Provides functions, classes and methods for graphic drawing.
+ *
+ * @{
+ */
+
 // Graphics modes
 #define INDEXED_1024_768        0x105
 #define DIRECT_640_480_888      0x110
@@ -19,7 +28,7 @@
 // Alpha
 #define ALPHA_THRESHOLD     0x7F
 
-/// MACROS
+// MACROS
 #define GET_ALP(n)          (0xFF & ((n) >> 24))
 #define GET_RED(n)          (0xFF & ((n) >> 16))
 #define GET_GRE(n)          (0xFF & ((n) >>  8))
@@ -31,62 +40,29 @@
 #define SET_BLU(n)          (((n)&0xFF)      )
 #define SET_RGB(r,g,b)      (SET_RED(r) | SET_GRE(g) | SET_BLU(b))
 
-/// PUBLIC GET
+// PUBLIC GET
 uint16_t   (graph_get_XRes)         (void);
 uint16_t   (graph_get_YRes)         (void);
 uint16_t   (graph_get_bytes_pixel)  (void);
 
-/// INIT
+// INIT
 int (graph_init)(uint16_t mode);
 
-/// CLEANUP
+// CLEANUP
 int (graph_cleanup)(void);
 
-/// PIXEL DRAWING
+// PIXEL DRAWING
 int (graph_set_pixel)             (uint16_t x, uint16_t y, uint32_t color);
 void (graph_set_pixel_pos)         (unsigned pos          , uint32_t color);
 
-/// SCREEN
+// SCREEN
 int (graph_clear_screen)(void);
 
-/// DRAW
+// DRAW
 int (graph_draw)(void);
 
-/// SPRITE ================================
-struct basic_sprite;
-typedef struct basic_sprite basic_sprite_t;
-
-basic_sprite_t* (basic_sprite_ctor)(const char *const *xpm, int16_t u0, int16_t v0);
-void            (basic_sprite_dtor)(basic_sprite_t *p);
-const uint8_t* (basic_sprite_get_map)(const basic_sprite_t *p);
-uint16_t       (basic_sprite_get_w)  (const basic_sprite_t *p);
-uint16_t       (basic_sprite_get_h)  (const basic_sprite_t *p);
-int16_t        (basic_sprite_get_u0) (const basic_sprite_t *p);
-int16_t        (basic_sprite_get_v0) (const basic_sprite_t *p);
-
-struct sprite;
-typedef struct sprite sprite_t;
-
-sprite_t* (sprite_ctor)(const basic_sprite_t *bsp);
-/*
- * /!\ WARNING: Entity destructor does not destruct the basic_sprite passed as
- * constructor arguments, since it is assumed the same basic_sprite may be used to
- * draw several sprites. It is thus YOUR responsibility to delete basic_sprite's.
- * @param   p   Pointer to sprite_t to be destructed
+/**
+ * @}
  */
-void      (sprite_dtor)(sprite_t *p);
 
-void (sprite_set_pos)   (sprite_t *p, int16_t x, int16_t y);
-void (sprite_set_center)(sprite_t *p, int16_t u0, int16_t v0);
-void (sprite_set_angle) (sprite_t *p, double angle);
-void (sprite_set_scale) (sprite_t *p, double scale);
-
-int16_t  (sprite_get_x)(const sprite_t *p);
-int16_t  (sprite_get_y)(const sprite_t *p);
-double   (sprite_get_angle)(const sprite_t *p);
-uint16_t (sprite_get_w)(const sprite_t *p);
-uint16_t (sprite_get_h)(const sprite_t *p);
-
-void (sprite_draw)(const sprite_t *p);
-
 #endif /* end of include guard: GRAPH_H_INCLUDED */
Index: proj/libs/graph/include/sprite.h
===================================================================
--- proj/libs/graph/include/sprite.h	(nonexistent)
+++ proj/libs/graph/include/sprite.h	(revision 331)
@@ -0,0 +1,43 @@
+#ifndef SPRITE_H_INCLUDED
+#define SPRITE_H_INCLUDED
+
+/**
+ * @defgroup sprite_t sprite_t
+ * @ingroup graph
+ * @brief Sprite module.
+ *
+ * A sprite allows to draw a basic_sprite_t, while also providing some transformations for that basic_sprite_t.
+ *
+ * @{
+ */
+
+struct sprite;
+typedef struct sprite sprite_t;
+
+sprite_t* (sprite_ctor)(const basic_sprite_t *bsp);
+/*
+ * /!\ WARNING: Entity destructor does not destruct the basic_sprite passed as
+ * constructor arguments, since it is assumed the same basic_sprite may be used to
+ * draw several sprites. It is thus YOUR responsibility to delete basic_sprite's.
+ * @param   p   Pointer to sprite_t to be destructed
+ */
+void      (sprite_dtor)(sprite_t *p);
+
+void (sprite_set_pos)   (sprite_t *p, int16_t x, int16_t y);
+void (sprite_set_center)(sprite_t *p, int16_t u0, int16_t v0);
+void (sprite_set_angle) (sprite_t *p, double angle);
+void (sprite_set_scale) (sprite_t *p, double scale);
+
+int16_t  (sprite_get_x)(const sprite_t *p);
+int16_t  (sprite_get_y)(const sprite_t *p);
+double   (sprite_get_angle)(const sprite_t *p);
+uint16_t (sprite_get_w)(const sprite_t *p);
+uint16_t (sprite_get_h)(const sprite_t *p);
+
+void (sprite_draw)(const sprite_t *p);
+
+/**
+ * @}
+ */
+
+#endif //SPRITE_H_INCLUDED

Property changes on: proj/libs/graph/include/sprite.h
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property